'FFSubmenu=Bilderlisten
'FFName=Verschieben / Kopieren

'(c) Harald Maeckler, Dsseldorf 2024
' ***********************************************************************
' ListToList.vbs (Skript fr FixFoto)
' Bilder in Bilderlisten verschieben bzw. kopieren
' ***********************************************************************

' Version 1.02 vom 07.05.2024	- Option 'autom. Beenden' hinzugefgt
'								- Kurzbeschreibung angepasst
' Version 1.01 vom 06.05.2024	- Kurzbeschreibung hinzugefgt
' Version 1.00 vom 03.05.2024	- Betaversion
' ***********************************************************************

'**Start Encode**

Option Explicit

'Updatekonstanten und Variable
const SkriptVersion = "1.02"
const SkriptURL = "https://www.ffsf.de/resources/listtolist.372/"
Dim UrlVersion,UrlV_Zahl,SkriptV_Zahl,SkriptEnde

'allgemeine Konstanten und Variable
const ForReading = 1, ForWriting = 2
Dim Abbruch,Antwort

'Spezifische Konstanten und Variable
Dim aktList,zielList,Handlung,flagEnd

'Objekte
Dim objFS,WshShell
Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

'Lschroutine
Dim SkriptKill,TempFile	 : SkriptKill = false
Dim SkriptName
const Skript = "ListToList"						'Skriptname
const RegSchluessel = "FF_ListToList"			'Registryschlssel

' ***********************************************************************
call main
Set WshShell = Nothing
Set objFS = Nothing
' ***********************************************************************

Sub main

on error resume next							'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	FF_GetScriptPath
 	if err <> 0 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

if objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbs") then
	SkriptName = Skript & ".vbs"
elseif objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbe") then
	SkriptName = Skript & ".vbe"
else
	msgbox "Das Skript wurde umbenannt!",vbCritical,"Abbruch"
	exit sub
end if

aktList = FF_IListGetCurrentList

'** Start Dialog ListToList **
FF_AddDialog "ListToList",180,105
FF_AddControl "ListToList","Zielliste","GROUP",5,37,170,25
FF_AddControl "ListToList","Aktuelle Liste","GROUP",5,5,170,25
FF_AddControl "ListToList","?","BUTTON",5,79,11,11
FF_AddControl "ListToList","|","STATIC",19,79,22,11
FF_SetControlStyle "ListToList","|",1
FF_AddControl "ListToList","Update","BUTTON",42,79,33,11
FF_AddControl "ListToList","Abbrechen","BUTTON",95,87,31,11
FF_AddControl "ListToList","Verschieben","BUTTON",142,87,33,11
FF_AddControl "ListToList","&delete","BUTTON",0,0,1,1
FF_AddControl "ListToList","||","STATIC",10,16,160,10
FF_SetControlStyle "ListToList","||",1
FF_AddControl "ListToList","|||","STATIC",10,46,160,10
FF_SetControlStyle "ListToList","|||",1
FF_AddControl "ListToList","Zielwahl","BUTTON",132,34,33,11
FF_AddControl "ListToList","Kopieren","BUTTON",142,71,33,11
FF_AddControl "ListToList","flagEnd","BOOL",83,73,8,8
FF_SetControlStyle "ListToList","flagEnd",16384
FF_AddControl "ListToList","nach Anwendung","STATIC",94,67,42,10
FF_AddControl "ListToList","autom. schlieen","STATIC",94,75,42,10
'** End Dialog ListToList **

call RegistryLesen

'Tooltips	
if Version_OK("3.30.06") then
	FF_SetControlTooltip "ListToList","?", "" &_
						 "Anzeige der Kurzbeschreibung"
	FF_SetControlTooltip "ListToList","Update", "" &_
						 "Prfung ob eine neue Version vorliegt"
	FF_SetControlTooltip "ListToList","Abbrechen", "" &_
						 "Skript beenden"
	FF_SetControlTooltip "ListToList","Kopieren", "" &_
						 "Markierte Bilder" & vbNewLine & "kopieren in Zielliste"
	FF_SetControlTooltip "ListToList","Verschieben", "" &_
						 "Markierte Bilder" & vbNewLine & "verschieben in Zielliste"
end if

if Version_OK("3.40.52") then FF_SetTooltipDelay 2500
FF_SetDialogTimer "ListToList", 100
FF_ActivateControl "ListToList","&delete"

do
	Abbruch = false
	Select Case FF_ShowDialog ("ListToList")
	
	Case "TIMER"
		FF_SetDialogTimer "ListToList", 0
		FF_SetControl "ListToList" ,"|", "V " & Skriptversion
		FF_SetControl "ListToList" ,"||", aktList
		FF_SetControl "ListToList","|||", zielList
	Case "&delete"
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "Zielwahl"
		call Zielbestimmung
		FF_SetControl "ListToList","|||",zielList
	Case "?"
		WshShell.Popup "" & _
			"ListToList" & vbNewLine &_
			"------------" & vbNewLine & vbNewLine &_
			"Das Skript erlaubt selektierte Bilder der aktuellen Bilderliste" & vbNewLine &_
			"in eine vorhandene, frei auswhlbare Zielliste zu kopieren" & vbNewLine &_
			"bzw. zu verschieben. Die Bilder werden in der Zielliste jeweils" & vbNewLine &_
			"ans Ende vorhandener Bilder gestellt." & vbNewLine &_
			"Ist die Option 'autom. schlieen' aktiviert, wird nach dem" & vbNewLine &_
			"Verschiebe- bzw. Kopiervorgang das Skript beendet." & vbNewLine &_
			"Anderenfalls bleibt das Skript bis zum 'Abbrechen' geffnet" & vbNewLine &_
			"um mehrere Bilder hintereinander manipulieren zu knnen." & vbNewLine & vbNewLine &_
			"Mit Bettigung der Tastenkombination Alt + D kann fr das" & vbNewLine &_
			"Skript eine Lschroutine aufgerufen werden." & vbNewLine & vbNewlIne &_
			"Copyright Harald Maeckler, 2024"& vbNewlIne &_
			"",,"Erluterungen",vbInformation
	Case "Update"
		if InternetConnection then
			SkriptEnde = false
			call Update
			if SkriptEnde then exit do
		end if
	Case "flagEnd"
		if FF_GetControl("ListToList","flagEnd") = 1 then flagEnd = 1 else flagEnd = 0
	Case "Abbrechen","CANCEL"
		exit do
	Case "Kopieren"
		Handlung = "Kopieren"
		call Werte_auslesen
		call Kontrolle
		if not Abbruch then
			call Schleife
			if not Abbruch then
				if flagEnd = 1 then exit do
			end if
		end if
	Case "Verschieben"
		Handlung = "Verschieben"
		call Werte_auslesen
		call Kontrolle
		if not Abbruch then
			call Schleife
			if not Abbruch then
				if flagEnd = 1 then exit do
			end if
		end if
		
	End Select
loop

call RegistrySchreiben
FF_CloseDialog ("ListToList")
if SkriptKill then			'ggf. Skript komplett entfernen
	call KillSkript
end if

end sub
'------------------------------------------------------------------------
Sub Zielbestimmung
Dim bild_array,element,tempZiellist

'** Start Dialog Bilderlisten **
FF_AddDialog "Bilderlisten",111,152
FF_AddControl "Bilderlisten","Listenbox","LISTBOX",5,5,100,130
FF_AddControl "Bilderlisten","Zielliste auswhlen per Doppelklick","STATIC",5,136,100,10
FF_SetControlStyle "Bilderlisten","Zielliste auswhlen per Doppelklick",1
'** End Dialog Bilderlisten **

bild_array = split(FF_IListGetLists,vbNewline)
'bild_array = split("Favoriten" & vbNewLine  & "Kalender 2020" & vbNewLine &  "Kalender 2021" & vbNewLine &  "Kalender 2023" & vbNewLine &  "Kalender 2024" & vbNewLine &  "Wettbewerb"  & vbNewLine &  "Familie" & vbNewLine & "Hunde",vbNewline)
for each element in bild_array
	FF_SetControl "Bilderlisten","Listenbox",element
next

do
	Select Case FF_ShowDialog ("Bilderlisten")
		Case "Listenbox"
			tempZiellist = FF_GetControl("Bilderlisten","Listenbox")
			if tempZiellist = aktList then
				msgbox "Die Zielliste darf nicht die aktuelle Liste sein!",vbExclamation,"Meldung"
				exit do
			else
				zielList = tempZiellist
			end if
			exit do
		Case "CANCEL"
			exit do
	End Select
loop

FF_CloseDialog ("Bilderlisten")

end sub
'------------------------------------------------------------------------
Sub Schleife
Dim bilder,bild_array,Anz,n

'Auswahl
'0 = alle Bilder des Computerverzeichnis
'1 = selekt. Bilder des Computerverzeichnis
'2 = alle Bilder der Bilderliste
'3 = selektierte Bilder der Bilderliste
'4 = Bilder des Computerverz. mit Unterordnern

bilder = FF_GetSelection(3)
if len(bilder) = 0 then
	msgbox "In der aktuellen Bilderliste sind keine Bilder markiert!",vbInformation,"Abbruch"
	Abbruch = true : exit sub
end if

bild_array = split(bilder,vbNewline)
Anz = ubound(bild_Array) +1
For n = 0 to Anz -1
	FF_IListInsertFile zielList,bild_Array(n),-1
	if Handlung = "Verschieben" then
		FF_IListDeleteFile aktList,bild_Array(n)
		FF_IListUpdate aktList
	end if
next

End Sub
'------------------------------------------------------------------------
Sub Werte_auslesen
	zielList = FF_GetControl("ListToList","|||")
	flagEnd = FF_GetControl("ListToList","flagEnd")
End Sub
'------------------------------------------------------------------------
Sub Kontrolle

if len(zielList) = 0 then
	msgbox "Es muss eine Zielliste ausgewhlt sein!",vbExclamation,"Meldung"
	Abbruch = true : exit sub
end if

End Sub
'------------------------------------------------------------------------
Sub RegistryLesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

'### Werte auslesen

'Zielliste
zielList = FF_GetProfile (RegSchluessel,"zielList")
if instr(FF_IListGetLists & vbNewLine,zielList & vbNewLine) = 0 then zielList = ""
if zielList = aktList then zielList = ""

'flagEnd
flagEnd = FF_GetProfile (RegSchluessel,"flagEnd")
if len(flagEnd) = 0 then flagEnd = 1

'### Werte eintragen
'in Timer eintragen > FF_SetControl "ListToList","|||",zielList
FF_SetControl "ListToList","flagEnd",flagEnd

End Sub
'------------------------------------------------------------------------
Sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

call Werte_Auslesen

'Werte schreiben
FF_WriteProfile RegSchluessel,"zielList",zielList
FF_WriteProfile RegSchluessel,"flagEnd",flagEnd

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Internetverbindung ?
'************************************************************************
'------------------------------------------------------------------------
Function InternetConnection
 
Dim obj
Set obj = GetObject("winmgmts:Win32_PingStatus.address='" & "google.de" & "'")

if IsNull(obj.StatusCode) or obj.StatusCode <> 0 Then
   msgbox "Keine Internetverbindung!",vbInformation,"Hinweis"
   InternetConnection = false
else
   InternetConnection = true
end if
 
End Function
'------------------------------------------------------------------------
'************************************************************************
'Update-Funktion
'************************************************************************
'------------------------------------------------------------------------
Sub Update
Dim Antwort

call Versionsermittlung_url

if not Abbruch then
	SkriptV_Zahl = Replace(SkriptVersion,".","") *1
	
	if UrlV_Zahl = SkriptV_Zahl then
		msgbox "Die Version " & SkriptVersion & " ist aktuell!",vbInformation,"Versionsmeldung"
	elseif SkriptV_Zahl < UrlV_Zahl then
		Antwort = msgbox("Die Skriptversion " & SkriptVersion & " ist nicht mehr aktuell!" & vbNewLine &_
				"Es steht die Version " & UrlVersion & " zum Download bereit." & vbNewLine & vbNewLine & _
				"Soll die Downloadseite aufgerufen werden?",vbQuestion + vbYesNo,"Versionsmeldung")
		if Antwort = vbYes then
			on error resume next
			WshShell.Run SkriptUrl,1,false
			if err <> 0 then
				msgbox "Die Downloadseite wurde nicht gefunden!",vbExclamation,"Hinweis"
			else
				SkriptEnde = true
			end if
			on error goto 0
		end if
	else
		msgbox 	"Es liegt ein Fehler in den Versionsangaben vor." & vbNewLine &_
				"Die Skriptversion " & SkriptVersion & " ist grer als die auf" & vbNewLine &_
				"der Downloadseite angegebene Version " & UrlVersion & ".",vbInformation,"Fehlermeldung"
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub Versionsermittlung_url

const VersVortext = "Version:"
Dim Inhalt,pos1,pos2,xml
Dim Fehler : Fehler = false

on error resume next

Set xml = CreateObject("Microsoft.XMLHTTP")
xml.Open "Get",SkriptUrl,false
xml.Send

Inhalt = xml.responseText

if err <> 0 then
	Fehler = true
else
	'Version suchen und anzeigen	
	pos1 = instr(Inhalt,VersVortext)
	if pos1 > 0 then
		pos2 = instr(pos1 ,Inhalt,".")
		if pos2 > 0 then
			pos2 = pos2 +3
			UrlVersion = trim(mid(Inhalt,pos1,pos2-pos1))
		else
			Fehler = true
		end if
	else
		Fehler = true
	end if
end if

Set xml = nothing
On Error GoTo 0

if Fehler then
	msgbox  "Die Versionsangabe wurde nicht gefunden!" & vbNewLine &_
			"Mglicherweise funktioniert der Internetaufruf nicht." & vbNewLine & vbNewLine & _
			"Am besten nochmal probieren!",vbExclamation,"Fehlermeldung"
	Abbruch = true
	exit sub
end if

'Version als Zahl
UrlVersion = trim(mid(UrlVersion,len(VersVortext) +1))
UrlV_Zahl = Replace(UrlVersion,".","") *1
'Msgbox "|" & UrlV_Zahl & "|"

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Lschroutine
'************************************************************************
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Dateien lschen
'TempFile = """" & FF_GetScriptPath & "\SetDate\SetDate.pdf" & """"			'Dateien
'if objFS.FileExists(TempFile) then objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Ordner lschen
'TempFile = FF_GetScriptPath & "\MeckiScript\SetDate"						'Ordner
'if objFS.FolderExists(TempFile) then objFS.DeleteFolder TempFile,true

'### ggf. Registry-Daten lschen
TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\" & RegSchluessel & "\"
WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Das Skript" & Skriptname & vbNewLine & "wurde mit allen Komponenten gelscht!" & vbNewLine & _
	   "Es wird empfohlen die 'Automatische Skriptkonfiguration' aufzurufen.",vbExclamation,"Hinweis"

End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Standard-Funktionen
'************************************************************************
'------------------------------------------------------------------------
Function Version_OK(MinVersion)
dim VersNr

 VersNr=split(MinVersion,".")
 Version_OK=FF_GetMajor * 1000 + FF_GetMinor + FF_GetBuild / 1000 >=_
     		VersNr(0) * 1000 + VersNr(1) + VersNr(2) / 1000

End Function
'------------------------------------------------------------------------
